#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#ifdef WIN32
#include <winsock.h>
#else
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <unistd.h>
#endif

#include <tcl.h>

int qsmack_gethostbyaddr(ClientData main, Tcl_Interp *interp, int argc, char **argv );

#ifdef WIN32
__declspec(dllexport) int
Tcl_qsmackfe_Init(Tcl_Interp *interp)
#else
int
Tcl_qsmackfe_Init(Tcl_Interp *interp)
#endif
{
    Tcl_CreateCommand( interp, "gethostbyaddr", qsmack_gethostbyaddr,
                       (ClientData) 0, (Tcl_CmdDeleteProc *) NULL );
    return TCL_OK;
}

int 
qsmack_gethostbyaddr(ClientData main, Tcl_Interp *interp, int argc, char **argv)
{
   unsigned long addr;
   struct hostent *hp;
   char tmp[50];

   if ( argc == 1 ) {
     Tcl_SetResult(interp, "No IP supplied", TCL_STATIC);
     return TCL_OK;
   }

   if( (addr = inet_addr(argv[1])) == INADDR_NONE ) {
     Tcl_SetResult( interp, "Bad IP format", TCL_STATIC );
     return TCL_OK;
   }

   if( (hp = gethostbyaddr((char *)&addr, sizeof (addr), AF_INET)) == NULL ) {
     sprintf(tmp, "Lookup failed for %s", argv[1]);
     Tcl_SetResult( interp, tmp, TCL_STATIC );
     return TCL_OK;
   } else {
     Tcl_SetResult( interp, hp->h_name, TCL_STATIC );
     return TCL_OK;
   }
}
